ARGUMENTS = [
    {
        "name": "k_value",
        "nickname": "k",
        "help_text": "Number of chunks to return",
        "type": int,
        "default": 15,
    },
    {
        "name": "libraries",
        "nickname": "l",
        "help_text": "Limit your chat to a list of libraries. Usage: -l library1 library2 library3",
        "type": list,
    },
    {
        "name": "model",
        "nickname": "m",
        "help_text": "Specify the model. Default: gpt-4",
        "type": str,
        "default": "gpt-4",
        "choices": [
            "gpt-4-1106-preview",
            "gpt-4",
            "gpt-3.5-turbo",
            "gpt-3.5-turbo-16k",
        ],
    },
    {
        "name": "cite_sources",
        "nickname": "c",
        "help_text": "Determines whether or not the AI model cites its sources",
        "type": bool,
        "default": True,
    },
]

LIBRARIES = [
    "python",
    "boto3",
    "urllib3",
    "botocore",
    "setuptools",
    "requests",
    "typing-extensions",
    "certifi",
    "charset-normalizer",
    "wheel",
    "cryptography",
    "python-dateutil",
    "idna",
    "pyyaml",
    "google-api-core",
    "six",
    "pytz",
    "numpy",
    "importlib-metadata",
    "pip",
    "packaging",
    "zipp",
    "awscli",
    "aiobotocore",
    "protobuf",
    "click",
    "pandas",
    "pyasn1",
    "rsa",
    "fsspec",
    "pyjwt",
    "jmespath",
    "markupsafe",
    "s3fs",
    "attrs",
    "cffi",
    "psutil",
    "lxml",
    "pydantic",
    "colorama",
    "platformdirs",
    "googleapis-common-protos",
    "pycparser",
    "google-auth",
    "pyopenssl",
    "virtualenv",
    "cachetools",
    "werkzeug",
    "jinja2",
    "jsonschema",
    "filelock",
    "flask",
    "sqlalchemy",
    "pyparsing",
    "docutils",
    "async-timeout",
    "tzlocal",
    "oauthlib",
    "pluggy",
    "tomli",
    "aiohttp",
    "grpcio",
    "requests-oauthlib",
    "pyarrow",
    "pytest",
    "wrapt",
    "tqdm",
    "soupsieve",
    "dnspython",
    "isodate",
    "azure-core",
    "frozenlist",
    "coverage",
    "pygments",
    "websocket-client",
    "beautifulsoup4",
    "pillow",
    "greenlet",
    "importlib-resources",
    "distlib",
    "yarl",
    "multidict",
    "scipy",
    "decorator",
    "aiofiles",
    "et-xmlfile",
    "openpyxl",
    "google-cloud-storage",
    "google-cloud-core",
    "httptools",
    "chardet",
    "iniconfig",
    "asn1crypto",
    "tomlkit",
    "tabulate",
    "more-itertools",
    "requests-toolbelt",
    "google-resumable-media",
    "paramiko",
    "aioconsole",
    "deprecated",
    "gitpython",
    "pynacl",
    "google-api-python-client",
    "pymysql",
    "psycopg2",
    "rpds-py",
    "proto-plus",
    "anyio",
    "itsdangerous",
    "msal",
    "referencing",
    "azure-storage-blob",
    "jsonschema-specifications",
    "bcrypt",
    "pathspec",
    "scikit-learn",
    "smmap",
    "msgpack",
    "matplotlib",
    "poetry-core",
    "keyring",
    "joblib",
    "regex",
    "mypy-extensions",
    "wcwidth",
    "docker",
    "sniffio",
    "google-auth-oauthlib",
    "kiwisolver",
    "portalocker",
    "pexpect",
    "ptyprocess",
    "jaraco-classes",
    "dill",
    "pyrsistent",
    "ruamel-yaml",
    "gitdb",
    "pycryptodomex",
    "sqlparse",
    "msrest",
    "google-crc32c",
    "sagemaker",
    "tenacity",
    "prompt-toolkit",
    "google-cloud-bigquery",
    "tzdata",
    "snowflake-connector-python",
    "gunicorn",
    "cython",
    "py4j",
    "py",
    "markdown",
    "azure-identity",
    "httplib2",
    "future",
    "fonttools",
    "alembic",
    "markdown-it-py",
    "cachecontrol",
    "awswrangler",
    "rich",
    "msal-extensions",
    "tornado",
    "threadpoolctl",
    "jedi",
    "marshmallow",
    "google-auth-httplib2",
    "traitlets",
    "cloudpickle",
    "shellingham",
    "redis",
    "pycodestyle",
    "backoff",
    "python-dotenv",
    "scramp",
    "toml",
    "h11",
    "pytest-cov",
    "termcolor",
    "trove-classifiers",
    "annotated-types",
    "uritemplate",
    "ipython",
    "pyzmq",
    "networkx",
    "xmltodict",
    "uvicorn",
    "pyspark",
    "pg8000",
    "mccabe",
    "ply",
    "prometheus-client",
    "prometheus-python",
    "redshift-connector",
    "oscrypto",
    "dulwich",
    "webencodings",
    "pyodbc",
    "pycryptodome",
    "httpx",
    "sortedcontainers",
    "httpcore",
    "jeepney",
    "mako",
    "babel",
    "poetry",
    "secretstorage",
    "defusedxml",
    "isort",
    "jsonpointer",
    "blinker",
    "black",
    "jupyter-client",
    "typing-inspect",
    "jupyter-core",
    "pymongo",
    "mdit-py-plugins",
    "datadog",
    "contourpy",
    "adal",
    "pkginfo",
    "parso",
    "tensorboard",
    "toolz",
    "pyflakes",
    "absl-py",
    "sentry-sdk",
    "xlrd",
    "requests-aws4auth",
    "flake8",
    "jsonpath-ng",
    "python-json-logger",
    "nbconvert",
    "pickleshare",
    "build",
    "mdurl",
    "backcall",
    "fastapi",
    "rapidfuzz",
    "argcomplete",
    "python-utils",
    "transformers",
    "matplotlib-inline",
    "setuptools-scm",
    "nbformat",
    "ipykernel",
    "databricks-cli",
    "notebook",
    "fastjsonschema",
    "jupyter-server",
    "mistune",
    "huggingface-hub",
    "kubernetes",
    "debugpy",
    "starlette",
    "arrow",
    "asttokens",
    "progressbar2",
    "tensorflow",
    "google-cloud-pubsub",
    "websockets",
    "astroid",
    "jsonpatch",
    "asynctest",
    "aioitertools",
    "imageio",
    "simplejson",
    "appdirs",
    "pyproject-hooks",
    "pylint",
    "pbr",
    "lazy-object-proxy",
    "multiprocess",
    "smart-open",
    "altair",
    "h5py",
    "asgiref",
    "backports-zoneinfo",
    "tinycss2",
    "entrypoints",
    "bleach",
    "oauth2client",
    "llvmlite",
    "numba",
    "cattrs",
    "crashtest",
    "mlflow",
    "send2trash",
    "shapely",
    "elasticsearch",
    "comm",
    "cleo",
    "orjson",
    "pendulum",
    "pytest-runner",
    "nbclient",
    "aenum",
    "pygithub",
    "identify",
    "msrestazure",
    "nodeenv",
    "mypy",
    "flatbuffers",
    "great-expectations",
    "mock",
    "jupyterlab-server",
    "zope-interface",
    "pytzdata",
    "loguru",
    "argon2-cffi",
    "tokenizers",
    "typeguard",
    "overrides",
    "tox",
    "requests-file",
    "humanfriendly",
    "json5",
    "xlsxwriter",
    "pysocks",
    "google-pasta",
    "cfgv",
    "pyathena",
    "gast",
    "azure-storage-file-datalake",
    "ipywidgets",
    "rfc3339-validator",
    "executing",
    "jupyterlab",
    "pre-commit",
    "django",
    "querystring-parser",
    "contextlib2",
    "cached-property",
    "installer",
    "deepdiff",
    "pure-eval",
    "tensorflow-serving-api",
    "nltk",
    "semver",
    "retry",
    "hvac",
    "pipenv",
    "uri-template",
    "torch",
    "execnet",
    "html5lib",
    "typer",
    "croniter",
    "lockfile",
    "slack-sdk",
    "watchdog",
    "dataclasses",
    "gremlinpython",
    "types-pyyaml",
    "tensorflow-io-gcs-filesystem",
    "setproctitle",
    "azure-mgmt-core",
    "responses",
    "sphinx",
    "statsmodels",
    "text-unidecode",
    "dataclasses-json",
    "pandocfilters",
    "pytest-xdist",
    "async-lru",
    "click-plugins",
    "opentelemetry-api",
    "selenium",
    "safetensors",
    "opencv-python",
    "python-slugify",
    "xgboost",
    "distro",
    "plotly",
    "sentencepiece",
    "webcolors",
    "types-requests",
    "rfc3986",
    "terminado",
    "jupyter-lsp",
    "rfc3986-validator",
    "configparser",
    "argon2-cffi-bindings",
    "cmake",
    "fastavro",
    "docopt",
    "unidecode",
    "retrying",
    "types-urllib3",
    "apache-airflow",
    "pytest-mock",
    "fqdn",
    "isoduration",
    "tblib",
    "prettytable",
    "semantic-version",
    "sympy",
    "seaborn",
    "confluent-kafka",
    "azure-keyvault-secrets",
    "opt-einsum",
    "faker",
    "jsonpickle",
    "mpmath",
    "patsy",
    "azure-mgmt-resource",
    "libclang",
    "opencensus",
    "antlr4-python3-runtime",
    "pysftp",
    "ordered-set",
    "pymssql",
    "db-dtypes",
    "astunparse",
    "inflection",
    "gcsfs",
    "thrift",
    "parsedatetime",
    "dask",
    "deprecation",
    "scikit-image",
    "azure-datalake-store",
    "moto",
    "zeep",
    "makefun",
    "pyhcl",
    "boto",
    "libcst",
    "graphviz",
    "stevedore",
    "gspread",
    "snowballstemmer",
    "ujson",
    "zope-event",
    "gevent",
    "pyproj",
    "checkov",
    "python-gnupg",
    "pathos",
    "trio",
    "trio-websocket",
    "azure-eventhub",
    "typed-ast",
    "kombu",
    "shap",
    "pox",
    "ppft",
    "datasets",
    "apscheduler",
    "torchvision",
    "click-man",
    "accelerate",
    "coloredlogs",
    "xxhash",
    "brotli",
    "mypy-boto3-rds",
    "docstring-parser",
    "applicationinsights",
    "apache-beam",
    "structlog",
    "tldextract",
    "lightgbm",
    "email-validator",
    "wandb",
    "cligj",
    "kafka-python",
    "pybind11",
    "fire",
    "celery",
    "wsproto",
    "pywavelets",
    "numexpr",
    "authlib",
    "datetime",
    "colorlog",
    "pathlib2",
    "uamqp",
    "texttable",
    "pytest-asyncio",
    "google-cloud-logging",
    "azure-cosmos",
    "delta-spark",
    "ecdsa",
    "nvidia-cudnn-cu11",
    "enum34",
    "flask-cors",
    "slicer",
    "spacy",
    "fiona",
    "python-jose",
    "watchtower",
    "unicodecsv",
    "imagesize",
    "schema",
    "alabaster",
    "kfp",
    "geopandas",
    "marshmallow-enum",
    "apache-airflow-providers-common-sql",
    "pyfunctional",
    "dbt-core",
    "validators",
    "keras-preprocessing",
    "holidays",
    "python-daemon",
    "readme-renderer",
    "djangorestframework",
    "pandas-gbq",
    "azure-storage-queue",
    "azure-servicebus",
    "hypothesis",
    "tifffile",
    "sshtunnel",
    "graphframes",
    "lz4",
    "kfp-server-api",
    "python-magic",
    "invoke",
    "avro-python3",
    "parse",
    "kfp-pipeline-spec",
    "freezegun",
    "constructs",
    "outcome",
    "python-multipart",
    "billiard",
    "monotonic",
    "pip-tools",
    "vine",
    "fasteners",
    "ddtrace",
    "databricks-sql-connector",
    "pycountry",
    "azure-keyvault-keys",
    "sendgrid",
    "click-repl",
    "srsly",
    "pika",
    "chex",
    "thinc",
    "ijson",
    "jira",
    "docker-pycreds",
    "hpack",
    "opencv-python-headless",
    "blis",
    "flask-sqlalchemy",
    "fuzzywuzzy",
    "xlwt",
    "imbalanced-learn",
    "qtconsole",
    "pydata-google-auth",
    "h2",
    "pyproject-api",
    "sh",
    "lit",
    "hyperframe",
    "stringcase",
    "astor",
    "langchain-guides",
    "langchain",
    "wasabi",
    "pytest-metadata",
    "bitarray",
    "pathtools",
    "catalogue",
    "nose",
    "yapf",
    "distributed",
    "amqp",
    "pathy",
    "qtpy",
    "types-pytz",
    "boto3-stubs",
    "triton",
    "office365-rest-python-client",
    "hatchling",
    "jupyter-console",
    "slackclient",
    "atomicwrites",
    "starkbank-ecdsa",
    "omegaconf",
    "editables",
    "uvloop",
    "humanize",
    "knack",
    "botocore-stubs",
    "iso8601",
    "smdebug-rulesconfig",
    "crcmod",
    "torchmetrics",
    "fastparquet",
    "python-levenshtein",
    "pytimeparse",
    "mypy-boto3-s3",
    "einops",
    "pywin32",
    "jpype1",
    "pydeequ",
    "cog",
    "azure-cli",
    "pymeeus",
    "types-six",
    "murmurhash",
    "ansible",
    "pyspnego",
    "inflect",
    "phonenumbers",
    "flask-wtf",
    "cymem",
    "preshed",
    "cdk-nag",
    "aws-requests-auth",
    "google-cloud-audit-log",
    "ua-parser",
    "jsondiff",
    "yamllint",
    "nbclassic",
    "cerberus",
    "lazy-loader",
    "dacite",
    "statsd",
    "cssselect",
    "dpath",
    "apispec",
    "gensim",
    "django-cors-headers",
    "ruff",
    "gradio",
    "convertdate",
    "scp",
    "geopy",
    "sqlalchemy-utils",
    "azure-data-tables",
    "pypdf2",
    "partd",
    "graphql-core",
    "python-gitlab",
    "ninja",
    "ratelimit",
    "junit-xml",
    "levenshtein",
    "fabric",
    "pydot",
    "azure-storage-file-share",
    "pytorch-lightning",
    "watchfiles",
    "types-setuptools",
    "requests-mock",
    "strip-hints",
    "keras-applications",
    "pyotp",
    "mashumaro",
    "apache-airflow-providers-http",
    "ipaddress",
    "timm",
    "click-didyoumean",
    "bytecode",
    "parameterized",
    "netaddr",
    "flask-appbuilder",
    "pyperclip",
    "openapi-spec-validator",
    "onnx",
    "marshmallow-sqlalchemy",
    "locket",
    "lark",
    "mysqlclient",
    "confection",
    "pytest-html",
    "azure-cosmosdb-table",
    "agate",
    "geographiclib",
    "types-paramiko",
    "pytest-rerunfailures",
    "pyserial",
    "spacy-loggers",
    "flask-login",
    "flask-jwt-extended",
    "azure-devops",
    "xarray",
    "spark-nlp",
    "dateparser",
    "onnxruntime",
    "twisted",
    "lightning-utilities",
    "wtforms",
    "jaydebeapi",
    "bokeh",
    "natsort",
    "google-cloud-bigtable",
    "grpcio-health-checking",
    "tensorflow-text",
    "twine",
    "commonmark",
    "grpcio-reflection",
    "flask-caching",
    "cron-descriptor",
    "pyaml",
    "geoip2",
    "nh3",
    "autopep8",
    "python-editor",
    "logbook",
    "ftfy",
    "cachelib",
    "datadog-api-client",
    "jupyter",
    "hologram",
    "protobuf3-to-dict",
    "ndg-httpsclient",
    "promise",
    "azureml-core",
    "pydub",
    "jax",
    "flit-core",
    "zstandard",
    "cssselect2",
    "minimal-snowplow-tracker",
    "dbt-extractor",
    "connexion",
    "azure-keyvault-certificates",
    "configargparse",
    "aniso8601",
    "cairocffi",
    "hyperlink",
    "cramjam",
    "elasticsearch-dsl",
    "mypy-boto3-redshift-data",
    "h3",
    "cairosvg",
    "maxminddb",
    "pytz-deprecation-shim",
    "reportlab",
    "langcodes",
    "pytest-forked",
    "pymupdf",
    "ansible-core",
    "cloudevents",
    "leather",
    "ddsketch",
    "jaxlib",
    "oldest-supported-numpy",
    "tiktoken",
    "supervisor",
    "diskcache",
    "functions-framework",
    "hdfs",
    "apache-airflow-providers-ssh",
    "gradio-client",
    "azure-multiapi-storage",
    "funcsigs",
    "azure-kusto-data",
    "envier",
    "pyhive",
    "types-protobuf",
    "django-filter",
    "elastic-transport",
    "parse-type",
    "types-python-dateutil",
    "boltons",
    "python-docx",
    "twilio",
    "twilio-python",
    "pgpy",
    "korean-lunar-calendar",
    "azure-eventgrid",
    "async-generator",
    "globus-sdk",
    "apache-airflow-providers-imap",
    "sentence-transformers",
    "mkdocs-material",
    "aws-xray-sdk",
    "resolvelib",
    "linkify-it-py",
    "setuptools-rust",
    "google",
    "terminaltables",
    "keystoneauth1",
    "apache-airflow-providers-ftp",
    "javaproperties",
    "sqlalchemy-redshift",
    "jdcal",
    "pep517",
    "incremental",
    "limits",
    "unittest-xml-reporting",
    "frozendict",
    "service-identity",
    "factory-boy",
    "ml-dtypes",
    "addict",
    "uc-micro-py",
    "shortuuid",
    "pypandoc",
    "blessed",
    "cx-oracle",
    "requests-ntlm",
    "django-extensions",
    "apache-airflow-providers-amazon",
    "python-keystoneclient",
    "bracex",
    "cmdstanpy",
    "apache-airflow-providers-sqlite",
    "cookiecutter",
    "types-cryptography",
    "flask-session",
    "timezonefinder",
    "magicattr",
    "pymsteams",
    "pylint-plugin-utils",
    "voluptuous",
    "langsmith",
    "cinemagoer",
    "passlib",
    "imdbpy",
    "emoji",
    "databricks-api",
    "configobj",
    "bandit",
    "ultralytics",
    "w3lib",
    "dirac",
    "backports-functools-lru-cache",
    "tableauserverclient",
    "automat",
    "pypika",
    "pydash",
    "py-cpuinfo",
    "mmh3",
    "tokenize-rt",
    "python-swiftclient",
    "tensorflow-hub",
    "librosa",
    "webdriver-manager",
    "constantly",
    "user-agents",
    "injector",
    "youtube-dl",
    "pdfminer-six",
    "markdown2",
    "ffmpy",
    "mergedeep",
    "netifaces",
    "databricks-sdk",
    "azure-keyvault-administration",
    "ephem",
    "flax",
    "urllib3-secure-extra",
    "looker-sdk",
    "kornia",
    "python3-openid",
    "userpath",
    "polars",
    "tensorboardx",
    "openapi-schema-validator",
    "jellyfish",
    "ray",
    "django-storages",
    "asyncpg",
    "dynamodb-json",
    "pycocotools",
    "lunarcalendar",
    "types-redis",
    "dm-tree",
    "flask-limiter",
    "scapy",
    "sacremoses",
    "hiredis",
    "netcdf4",
    "pyhocon",
    "cmaes",
    "feedparser",
    "firebase-admin",
    "yacs",
    "prison",
    "pytest-localserver",
    "polling2",
    "flask-babel",
    "influxdb",
    "binaryornot",
    "psycopg3",
    "sarif-om",
    "jschema-to-python",
    "cfn-flip",
    "google-apitools",
    "ipdb",
    "pyrfc3339",
    "filterpy",
    "py-spy",
    "wcmatch",
    "launchdarkly-server-sdk",
    "pyelftools",
    "logging-azure-rest",
    "python-jenkins",
    "apache-airflow-providers-cncf-kubernetes",
    "google-ads",
    "clickclick",
    "streamlit",
    "pylint-django",
    "yq",
    "findspark",
    "pycares",
    "mkdocs",
    "pytimeparse2",
    "ldap3",
    "pyee",
    "pydocstyle",
    "catboost",
    "sqlalchemy-jsonfield",
    "optuna",
    "aws-lambda-powertools",
    "lru-dict",
    "rasterio",
    "cartoframes",
    "carto",
    "aiodns",
    "pyrestcli",
    "opentracing",
    "tensorflow-datasets",
    "apache-airflow-providers-google",
    "jsonlines",
    "azure",
    "backports-weakref",
    "diff-cover",
    "cftime",
    "azure-kusto-ingest",
    "qrcode",
    "redis-py-cluster",
    "diffusers",
    "grpclib",
    "pypdf",
    "thrift-sasl",
    "django-debug-toolbar",
    "dynaconf",
    "django-redis",
    "salesforce-bulk",
    "kazoo",
    "configupdater",
    "comtypes",
    "langdetect",
    "hydra-core",
    "pytest-django",
    "pywin32-ctypes",
    "pyminizip",
    "pathvalidate",
    "google-re2",
    "idna-ssl",
    "dagster-pandas",
    "toposort",
    "expiringdict",
    "rdflib",
    "etils",
    "rich-argparse",
    "xyzservices",
    "bottle",
    "oslo-utils",
    "prophet",
    "pdfplumber",
    "azure-mgmt-subscription",
    "parsl",
    "jsii",
    "click-option-group",
    "analytics-python",
    "home-run",
    "funcx",
    "funcx-common",
    "lmdb",
    "zict",
    "multi-key-dict",
    "hatch-fancy-pypi-readme",
    "googlemaps",
    "pyudev",
    "atlassian-python-api",
    "dohq-artifactory",
    "oslo-i18n",
    "whitenoise",
    "aiosqlite",
    "python-engineio",
    "enum-compat",
    "affine",
    "fs",
    "flake8-bugbear",
    "hyperopt",
    "multipledispatch",
    "oslo-serialization",
    "pygeohash",
    "somnium",
    "kaleido",
    "python-snappy",
    "python-pptx",
    "gql",
    "pymdown-extensions",
    "wexpect",
    "types-pyopenssl",
    "foundationdb",
    "jsonschema-spec",
    "iopath",
    "snuggs",
    "strict-rfc3339",
    "tablib",
    "orderedmultidict",
    "sqlglot",
    "fakeredis",
    "pystan",
    "python-socketio",
    "robotframework",
    "pkgconfig",
    "pycairo",
    "python-consul",
    "curlify",
    "types-toml",
    "backports-tempfile",
    "multimethod",
    "pynamodb",
    "docker-compose",
    "munch",
    "torchaudio",
    "elementpath",
    "mypy-boto3-lambda",
    "python-decouple",
    "mypy-boto3-dynamodb",
    "pylev",
    "pmdarima",
    "drf-yasg",
    "path",
    "pyxlsb",
    "pandasql",
    "pipdeptree",
    "debtcollector",
    "nvidia-ml-py",
    "pyinstaller-hooks-contrib",
    "dvclive",
    "koalas",
    "arviz",
    "coreapi",
    "sqlalchemy-bigquery",
    "pyquery",
    "webob",
    "faiss-cpu",
    "flower",
    "cloudformation-cli",
    "azureml-dataset-runtime",
    "azure-mgmt",
    "cloudformation-cli-java-plugin",
    "pyinstaller",
    "python-box",
    "pympler",
    "mypy-boto3-secretsmanager",
    "marshmallow-oneofschema",
    "schedule",
    "resampy",
    "bitstring",
    "timeout-decorator",
    "furl",
    "bidict",
    "setuptools-git",
    "jsonmerge",
    "htmlmin",
    "plumbum",
    "gdown",
    "evergreen-py",
    "tableauhyperapi",
    "xformers",
    "yt-dlp",
    "waitress",
    "mypy-boto3-cloudformation",
    "tld",
    "pipx",
    "fake-useragent",
    "junitparser",
    "pylint-flask",
    "jaraco-functools",
    "geomet",
    "yappi",
    "flask-openid",
    "apache-airflow-providers-snowflake",
    "ciso8601",
    "paho-mqtt",
    "aiohttp-retry",
    "smbprotocol",
    "mypy-protobuf",
    "msgpack-python",
    "dockerpty",
    "cssutils",
    "djangorestframework-simplejwt",
    "wordcloud",
    "pytest-env",
    "django-environ",
    "s3cmd",
    "graphene",
    "soundfile",
    "html2text",
    "dagster-dbt",
    "apache-airflow-providers-databricks",
    "python-nvd3",
    "pygobject",
    "azureml-sdk",
    "click-default-group",
    "azureml-dataprep",
    "pygit2",
    "boto3-type-annotations",
    "imagehash",
    "ec2-metadata",
    "requests-futures",
    "rx",
    "geventhttpclient",
    "wget",
    "xmlschema",
    "python-rapidjson",
    "playwright",
    "flatten-json",
    "collections-extended",
    "myst-parser",
    "flask-restful",
    "facebook-business",
    "pdpyras",
    "python-crfsuite",
    "pydeck",
    "dash-core-components",
    "publication",
    "zthreading",
    "cheroot",
    "minio",
    "uwsgi",
    "portpicker",
    "simplegeneric",
    "python-crontab",
    "basicsr",
    "facexlib",
    "testpath",
    "json-log-formatter",
    "ghp-import",
    "sseclient-py",
    "ansi2html",
    "jproperties",
    "django-timezone-field",
    "duckdb",
    "pygsheets",
    "pyzstd",
    "opencv-contrib-python",
    "pyyaml-env-tag",
    "pyaes",
    "pooch",
    "funcy",
    "appnope",
    "cerberus-python-client",
    "realesrgan",
    "readchar",
    "cassandra-driver",
    "requests-unixsocket",
    "pyproject-metadata",
    "dictdiffer",
    "pypng",
    "ffmpeg-python",
    "locust",
    "pymc",
    "modelx",
    "ffn",
    "finance-py",
    "gs-quant",
    "tf-quant-finance",
    "finta",
    "qstrader",
    "blankly",
    "ta-lib-python",
    "zipline",
    "bt",
    "backtrader",
    "pyalgotrade",
    "pandas-ta",
    "ta",
    "finmarket-py",
    "zvt",
    "py-portfolio-opt",
    "eiten",
    "backtesting-py",
    "quantstats",
    "qtpylib",
    "freqtrade",
    "qlib",
    "jesse",
    "finrl",
    "bulbea",
    "octobot",
    "tda-api",
    "vectorbt",
    "lean",
    "pybroker",
    "pyfolio",
    "empyrical",
    "finquant",
    "riskfolio-lib",
    "alphalens",
    "arch",
    "pyflux",
    "tsfresh",
    "gluonts",
    "yfinance",
    "alpha-vantage",
    "pandas-datareader",
    "yahoo-finance",
    "findatapy",
    "wallstreet",
    "alpaca-trade-api-python",
    "investpy",
    "xlwings",
    "dtale",
    "mplfinance",
    "keras",
    "opensearch-py",
    "openai",
    "dash",
    "stripe",
]
